# Exercise 3

# Generate a sample of the numbers of phone calls
# to the emergency room from 10am to 11am, for 100 days,
# knowing that the expected number of calls in this period per day is 25.

l <- 25
sample1 <- rpois(10, lambda = l)

plot(sample1)
mean(sample1)
sd(sample1)
barplot(table(sample1))

# Create samples with the same parameter lambda = 25
# and of different sizes: 10, 100, 1000, 10000, 100000.
sample2 <- rpois(100, lambda = l)
sample3 <- rpois(1000, lambda = l)
sample4 <- rpois(10000, lambda = l)
sample5 <- rpois(100000, lambda = l)

barplot(table(sample2))
barplot(table(sample3))
barplot(table(sample4))
barplot(table(sample5))


# Create a sample of a normally distributed random variable
# with mean 25 and standard deviation 5 and with the size 100000.

sample6 <- rnorm(100000, mean = 25, sd = 5)
hist(sample6, breaks = seq(0, 50, 1))
hist(sample5, breaks = seq(0, 50, 1))

# Conclusion - For a large number of events we can approximate
# the Poisson distribution with Normal distribution


# Exercise 4

n <- 150
p <- 0.3

village <- rbinom(n, size = 1, prob = p)
plot(village)
table(village)
barplot(table(village))

nb_sick_people <- sum(village)


# Simulate the numbers of sick people in 10 different villages of Imaginaria.

N <- 10
villages <- rbinom(N, size = n, prob = p)
mean(villages)
sd(villages)
summary(villages)
barplot(table(villages))

# Simulate numbers of sick people in 100, 1000, 10000 different villages of Imaginaria.
N <- 100
villages1 = rbinom(N, size = n, prob = p)
barplot(table(villages1))

N <- 1000
villages2 = rbinom(N, size = n, prob = p)
barplot(table(villages2))


N <- 10000
villages3 = rbinom(N, size = n, prob = p)
barplot(table(villages3))


# Create a sample of a normally distributed random variable
# with mean 150x0.3 and standard deviation 150x0.3x0.7 and with the size 10000.

sample <- rnorm(N, mean = n*p, sd = sqrt(n*p*(1-p)))
hist(sample, breaks = seq(15,75,1))
hist(villages3, breaks = seq(15,75,1))


dens3 <- density(villages3)
dens <- density(sample)
plot(dens, col = 1, main = "Density functions", xlab = "Sick people")
lines(dens3, col = 2)

# Conclusion - For a large number of events we can approximate the binomial distribution
# with a normal distribution

# The approximation with a normal distribution is convenient
# as a lot of mathematical theory has been developed
# for random variables with normal distribution.
# As it is a go-to distribution for modelling many phenomena,
# there is a lot of literature, software etc. on the subject.
# But Poisson, Binomial and Bernoulli distributions are very useful too,
# and especially when number of events is not high enough
# and they can not be approximated with the Normal distribution.
# More about it in the course of the following week.

# Further challenge for you - make this file nicer.
# 1) Create your own functions for analysis of a sample.
# 2) Transform it to Rmarkdwn file.

